        OMIT('Comment Block')
        
Class for printing directly to a Windows Print Spooler, bypassing the driver code.

Most of the working code (found in DirectPrint.CLW) was written by 
Trevor G. Leybourne

Work:     +44 (0)1959-491238
Mobile:   +44 (0)7979-518933

E-Mail:   trevor.leybourne@jdaintl.co.uk
              trevor@yellowchicken.com

Original Code can be found at this address:
http://http://www.icetips.com/ftp/misc_files/
        Files: PrintDrv.txt
               PrintDrv.zip
               
2005-05-10 - Code converted into an ABC Class library, by
             Jim Gambon <clarioncoder@jndata.com>
             
             Names of all procedures and API prototypes and structures prefaced
             with DP_ or DPAPI_ to keep possible namespace conflicts from happening.

2011-04-19 - L Jack Wilson Changes:
             1. Added LinePrint (Wrapper to WriteText) to mimic LinePrint from Nova Templates
             2. Changed from an abc library to an internal class
             3. Fixed bug (omitted AppendCRLF was defaulting to false, not TRUE as stated in docs
        
        ! END Comment Block
            


DP_HANDLE                  EQUATE(UNSIGNED)
DP_LPCSTR                  EQUATE(CSTRING)    !Usage:Pass the Label of the LPCSTR
DP_LPCTSTR                 EQUATE(DP_LPCSTR)
DP_HDC                     EQUATE(DP_HANDLE)
DP_LPSTR                   EQUATE(CSTRING)    !Usage:Pass the Label of the LPSTR
DP_LPVOID                  EQUATE(ULONG)
DP_DWORD                   EQUATE(ULONG)
DP_LPHANDLE                EQUATE(DP_HANDLE)
DP_LPBOOL                  EQUATE(ULONG)
DP_WORD                    EQUATE(SHORT)       ! Was UNSIGNED (4 Bytes) should be SHORT (2 BYTES)
DP_HDC                     EQUATE(DP_HANDLE)
DP_HFONT                   EQUATE(DP_HANDLE)
DP_HGDIOBJ                 EQUATE(DP_HANDLE)
DP_HINSTANCE               EQUATE(DP_HANDLE)
DP_HWND                    EQUATE(DP_HANDLE)
DP_HGLOBAL                 EQUATE(DP_HANDLE)
DP_HBITMAP                 EQUATE(DP_HANDLE)
DP_NULL                    EQUATE('<00h>')


DirectPrintClass  CLASS,MODULE('DirectPrint.CLW'),TYPE,LINK('DirectPrint.CLW')
PrinterHandle        DP_HANDLE
PrinterInited        SHORT

                ! Public Methods
Initialize           PROCEDURE(<STRING p:PrinterName>),VIRTUAL,BYTE           ! Declare Procedure
Finalize             PROCEDURE(BYTE p:ThreadFlag = 0),VIRTUAL                   ! Declare Procedure
WriteText            PROCEDURE(STRING p:TextToWrite,ULONG p:Len,BYTE p:AppendCRLF=TRUE),VIRTUAL,BYTE,PROC ! Declare Procedure
LinePrint            PROCEDURE(STRING p:TextToWrite),VIRTUAL                    ! Declare Procedure !ljw 2011/04/19 added

                ! Private Methods
GetDefaultPrinter    PROCEDURE(),STRING,PROTECTED                  ! Declare Procedure
GetPrinterhandle     PROCEDURE(),DP_HANDLE,PROTECTED                   ! Declare Procedure
GetStringElement     PROCEDURE(BYTE p:Element,STRING p:Seperator,STRING p:StringToSeperate),STRING,PROTECTED ! Declare Procedure
SetPrinterHandle     PROCEDURE(DP_HANDLE p:PrinterHandle),PROTECTED    ! Declare Procedure
SetStructNull        PROCEDURE(*STRING p:Structure, LONG p:Size),PROTECTED   ! Declare Procedure
PrintJobOpen         PROCEDURE(),BYTE,PROTECTED                         ! Declare Procedure
PrintJobClose        PROCEDURE(),PROTECTED                         ! Declare Procedure
                  END !CLASS      
                  

